//---------------------------------------------------------------------------
#include <vcl.h>
#include <string.h>
#pragma hdrstop

#include "SystemAdapter.h"
#include "MainFrm.h"
#include "GameField.h"
#include "MovingCharacter.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

SystemAdapter::SystemAdapter()
{

}


void SystemAdapter::setLabelRemoved(int player,int killNum) {
    TLabel *labels[2] = {
        frmMain->lblRemove1,
        frmMain->lblRemove2
    };

    labels[player]->Caption=(IntToStr(killNum));

}

void SystemAdapter::setSingleLabelRemoved(int killNum) {
    frmMain->lbl1pKillnum->Caption = (IntToStr(killNum)+" C");


}

void SystemAdapter::setSingleLabelLevel(int lv) {
    frmMain->lbl1pLevel->Caption = ("Level\n"+IntToStr(lv));
}


void SystemAdapter::setSingleLabelBonus(char *txt)
{
    char str[255];
    strcpy(str,txt) ;
    frmMain->lbl1pBonus->Caption = str;
}


void SystemAdapter::setSingleLabelChain(char *txt)
{
    char str[255];
    strcpy(str,txt) ;
    frmMain->lbl1pChain->Caption = str;
}


void SystemAdapter::setSingleLabelScore(char *txt)
{
 //   char str[255];
 //   strcpy(str,txt);
 //   frmMain->lbl1pScore->Caption = str;
}

// wii`Ă摜āj`
void SystemAdapter::drawBackground(GameField *sc)
{
    BitBlt (imageMain[sc->getID()]->Canvas->Handle,0,0,
         mainx*KOMA_WIDTH,mainy * KOMA_HEIGHT,
         frmMain->imgBack->Canvas->Handle,0,0,SRCCOPY);

}

// ς܂ꂽL̕`
void SystemAdapter::drawStackedCharacter(GameField *sc)
{
	int i,j;

	for (i= 1;i<=mainx;i++)
		for(j=1;j<=mainy;j++) {
			BitBlt(imageMain[sc->getID()]->Canvas->Handle,KOMA_WIDTH*(i-1),KOMA_HEIGHT*(mainy-j),
              KOMA_WIDTH,KOMA_HEIGHT,imageCharacter[sc->tumiage_chr[i][j]]->Canvas->Handle,
              0,KOMA_HEIGHT,SRCERASE);
			BitBlt(imageMain[sc->getID()]->Canvas->Handle,KOMA_WIDTH*(i-1),KOMA_HEIGHT*(mainy-j),
              KOMA_WIDTH,KOMA_HEIGHT,imageCharacter[sc->tumiage_chr[i][j]]->Canvas->Handle,
              0,0,SRCINVERT);
		}

}


// wiƉɐςݏグꂽL`()
void SystemAdapter::drawBackgroundAndStackedCharacter(GameField * sc, bool refresh)
{
  int i,j;

  if (refresh || sc->isRefresh) {

    BitBlt (imageBuffer[sc->getID()]->Canvas->Handle,0,0,
       mainx * KOMA_WIDTH, mainy * KOMA_HEIGHT,
       frmMain->imgBack->Canvas->Handle,0,0,SRCCOPY);


    for (i= 1;i<=mainx;i++) {
      for(j=1;j<=mainy;j++) {

        if (sc->tumiage_chr[i][j] != 0 ) {

          if ( (sc->blinkCount % 2) != 0 && sc->syometu_flg[i][j] == true) {
              ; // nothing to do.
          }
          else {

            BitBlt(imageBuffer[sc->getID()]->Canvas->Handle,KOMA_WIDTH*(i-1),KOMA_HEIGHT*(mainy-j),
              KOMA_WIDTH,KOMA_HEIGHT,imageCharacter[sc->tumiage_chr[i][j]]->Canvas->Handle,
              0,KOMA_HEIGHT,SRCERASE);
            BitBlt(imageBuffer[sc->getID()]->Canvas->Handle,KOMA_WIDTH*(i-1),KOMA_HEIGHT*(mainy-j),
              KOMA_WIDTH,KOMA_HEIGHT,imageCharacter[sc->tumiage_chr[i][j]]->Canvas->Handle,
              0,0,SRCINVERT);
          }
        }

      }
    }


    sc->isRefresh = false;

  }

  BitBlt (imageMain[sc->getID()]->Canvas->Handle,0,0,224,320,
     imageBuffer[sc->getID()]->Canvas->Handle,0,0,SRCCOPY);

  if (sc->blinkCount == 1) {

    // L
    for (i=1;i<=mainx;i++) {
      for (j=1;j<=mainy+4;j++) {

        if (sc->syometu_flg[i][j] == true) {
           sc->tumiage_chr[i][j] = 0;

           sc->killnum++;
        }

        sc->syometu_flg[i][j] = false;
      }
    }

  }

}

void  SystemAdapter::refreshImageMain(int id_num) {
    imageMain[id_num]->Refresh();

}




void SystemAdapter::drawMovingCharacter(MovingCharacter * movChar)
{
    int nowID = movChar->getID();

    BitBlt (imageMain[nowID]->Canvas->Handle,movChar->x1,movChar->y1,
        KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->kind1]->Canvas->Handle,0,KOMA_HEIGHT,SRCERASE);
	BitBlt (imageMain[nowID]->Canvas->Handle,movChar->x1,movChar->y1,
        KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->kind1]->Canvas->Handle,0,0,SRCINVERT);

    BitBlt (imageMain[nowID]->Canvas->Handle,movChar->x2,movChar->y2,
        KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->kind2]->Canvas->Handle,0,KOMA_HEIGHT,SRCERASE);
	BitBlt (imageMain[nowID]->Canvas->Handle,movChar->x2,movChar->y2,
        KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->kind2]->Canvas->Handle,0,0,SRCINVERT);

    imageMain[nowID]->Refresh();
}


void SystemAdapter::drawNextArea(MovingCharacter * movChar)
{
    int nowID = movChar->getID();
	// ܂obNɂ
    BitBlt (imageNext[nowID]->Canvas->Handle,0,0,KOMA_WIDTH,KOMA_HEIGHT*2,
        imageNext[nowID]->Canvas->Handle,0,0,BLACKNESS);

	BitBlt (imageNext[nowID]->Canvas->Handle,0,KOMA_HEIGHT,KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->next1]->Canvas->Handle,0,KOMA_HEIGHT,SRCERASE);
	BitBlt (imageNext[nowID]->Canvas->Handle,0,KOMA_HEIGHT,KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->next1]->Canvas->Handle,0,0,SRCINVERT);

	BitBlt (imageNext[nowID]->Canvas->Handle, 0,0,KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->next2]->Canvas->Handle,0,KOMA_HEIGHT,SRCERASE);
	BitBlt (imageNext[nowID]->Canvas->Handle, 0,0,KOMA_WIDTH,KOMA_HEIGHT,
		imageCharacter[movChar->next2]->Canvas->Handle,0,0,SRCINVERT);

	imageNext[nowID]->Refresh();
}

